package net.mcreator.puzzle_code.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.WidgetSprites;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.puzzle_code.world.inventory.TutorialGadgetGUIMenu;
import net.mcreator.puzzle_code.procedures.ReturnTitleTutorial5Procedure;
import net.mcreator.puzzle_code.procedures.ReturnTitleTutorial4Procedure;
import net.mcreator.puzzle_code.procedures.ReturnTitleTutorial3Procedure;
import net.mcreator.puzzle_code.procedures.ReturnTitleTutorial2Procedure;
import net.mcreator.puzzle_code.procedures.ReturnTitleTutorial1Procedure;
import net.mcreator.puzzle_code.procedures.ReturnSubtitleTutorial5Procedure;
import net.mcreator.puzzle_code.procedures.ReturnSubtitleTutorial4Procedure;
import net.mcreator.puzzle_code.procedures.ReturnSubtitleTutorial3Procedure;
import net.mcreator.puzzle_code.procedures.ReturnSubtitleTutorial2Procedure;
import net.mcreator.puzzle_code.procedures.ReturnSubtitleTutorial1Procedure;
import net.mcreator.puzzle_code.procedures.ReturnPagePlusOneProcedure;
import net.mcreator.puzzle_code.network.TutorialGadgetGUIButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class TutorialGadgetGUIScreen extends AbstractContainerScreen<TutorialGadgetGUIMenu> {
	private final static HashMap<String, Object> guistate = TutorialGadgetGUIMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	ImageButton imagebutton_left_button;
	ImageButton imagebutton_right_button;
	ImageButton imagebutton_enter_button;
	ImageButton imagebutton_enter_button1;
	ImageButton imagebutton_enter_button2;
	ImageButton imagebutton_enter_button3;
	ImageButton imagebutton_enter_button4;

	public TutorialGadgetGUIScreen(TutorialGadgetGUIMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 176;
		this.imageHeight = 167;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("puzzle_code:textures/screens/tutorial_gadget_gui.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);

		guiGraphics.blit(ResourceLocation.parse("puzzle_code:textures/screens/w_divider_1.png"), this.leftPos + 6, this.topPos + 30, 0, 0, 160, 4, 160, 4);

		guiGraphics.blit(ResourceLocation.parse("puzzle_code:textures/screens/w_divider_1.png"), this.leftPos + 6, this.topPos + 156, 0, 0, 160, 4, 160, 4);

		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font,

				ReturnPagePlusOneProcedure.execute(entity), 33, 12, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnTitleTutorial1Procedure.execute(entity), 29, 39, -16737793, false);
		guiGraphics.drawString(this.font,

				ReturnTitleTutorial2Procedure.execute(entity), 29, 61, -16737793, false);
		guiGraphics.drawString(this.font,

				ReturnTitleTutorial3Procedure.execute(entity), 29, 84, -16737793, false);
		guiGraphics.drawString(this.font,

				ReturnSubtitleTutorial1Procedure.execute(entity), 29, 48, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnSubtitleTutorial2Procedure.execute(entity), 29, 70, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnSubtitleTutorial3Procedure.execute(entity), 29, 93, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnTitleTutorial4Procedure.execute(entity), 29, 106, -16737793, false);
		guiGraphics.drawString(this.font,

				ReturnTitleTutorial5Procedure.execute(entity), 29, 129, -16737793, false);
		guiGraphics.drawString(this.font,

				ReturnSubtitleTutorial4Procedure.execute(entity), 29, 115, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnSubtitleTutorial5Procedure.execute(entity), 29, 138, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		imagebutton_left_button = new ImageButton(this.leftPos + 6, this.topPos + 7, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/left_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/left_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new TutorialGadgetGUIButtonMessage(0, x, y, z));
						TutorialGadgetGUIButtonMessage.handleButtonAction(entity, 0, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_left_button", imagebutton_left_button);
		this.addRenderableWidget(imagebutton_left_button);
		imagebutton_right_button = new ImageButton(this.leftPos + 146, this.topPos + 7, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/right_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/right_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new TutorialGadgetGUIButtonMessage(1, x, y, z));
						TutorialGadgetGUIButtonMessage.handleButtonAction(entity, 1, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_right_button", imagebutton_right_button);
		this.addRenderableWidget(imagebutton_right_button);
		imagebutton_enter_button = new ImageButton(this.leftPos + 6, this.topPos + 39, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/enter_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/enter_button_hovered.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new TutorialGadgetGUIButtonMessage(2, x, y, z));
						TutorialGadgetGUIButtonMessage.handleButtonAction(entity, 2, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_enter_button", imagebutton_enter_button);
		this.addRenderableWidget(imagebutton_enter_button);
		imagebutton_enter_button1 = new ImageButton(this.leftPos + 6, this.topPos + 61, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/enter_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/enter_button_hovered.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new TutorialGadgetGUIButtonMessage(3, x, y, z));
						TutorialGadgetGUIButtonMessage.handleButtonAction(entity, 3, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_enter_button1", imagebutton_enter_button1);
		this.addRenderableWidget(imagebutton_enter_button1);
		imagebutton_enter_button2 = new ImageButton(this.leftPos + 6, this.topPos + 84, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/enter_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/enter_button_hovered.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new TutorialGadgetGUIButtonMessage(4, x, y, z));
						TutorialGadgetGUIButtonMessage.handleButtonAction(entity, 4, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_enter_button2", imagebutton_enter_button2);
		this.addRenderableWidget(imagebutton_enter_button2);
		imagebutton_enter_button3 = new ImageButton(this.leftPos + 6, this.topPos + 106, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/enter_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/enter_button_hovered.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new TutorialGadgetGUIButtonMessage(5, x, y, z));
						TutorialGadgetGUIButtonMessage.handleButtonAction(entity, 5, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_enter_button3", imagebutton_enter_button3);
		this.addRenderableWidget(imagebutton_enter_button3);
		imagebutton_enter_button4 = new ImageButton(this.leftPos + 6, this.topPos + 129, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/enter_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/enter_button_hovered.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new TutorialGadgetGUIButtonMessage(6, x, y, z));
						TutorialGadgetGUIButtonMessage.handleButtonAction(entity, 6, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_enter_button4", imagebutton_enter_button4);
		this.addRenderableWidget(imagebutton_enter_button4);
	}
}
